#include <sourcemod>

#define DEBUG 0

public Plugin:myinfo =
{
	name = "L4D Idle Fix",
	author = "ArmGadge",
	description = "Fix the takeover bot glitch on multiple slots server",
	version = "1.0.0",
	url = "http://radiowave.moe.hm/"
};

new Handle:Timer_Delay[MAXPLAYERS+1] = INVALID_HANDLE;
new String:logpath[255];

public OnPluginStart()
{
	HookEvent("player_bot_replace", Event_PlayerBot);
	BuildPath(Path_SM, logpath, sizeof(logpath), "logs/l4d_idlefix.log");
}

public Event_PlayerBot(Handle:event, const String:name[], bool:dontBroadcast)
{
	new cid_player = GetClientOfUserId(GetEventInt(event, "player"));
	new cid_bot = GetClientOfUserId(GetEventInt(event, "bot"));
	new Handle:pack;
	if (cid_player)
	{
		Timer_Delay[cid_player] = CreateDataTimer(1.0, CheckDelay, pack);
		WritePackCell(pack, cid_player);
		WritePackCell(pack, cid_bot);
#if DEBUG
		new specuid_bot = GetEntProp(cid_bot, Prop_Send, "m_humanSpectatorUserID");
		new speccid_bot = GetEntProp(cid_bot, Prop_Send, "m_humanSpectatorEntIndex");
		LogToFile(logpath, "specuid_bot:%d, speccid_bot:%d", specuid_bot, speccid_bot);
#endif
	}

}
public Action:CheckDelay(Handle:timer, Handle:pack)
{
	ResetPack(pack);
	new cid_player = ReadPackCell(pack);
	new cid_bot = ReadPackCell(pack);
	new obst = GetEntPropEnt(cid_player, Prop_Send, "m_hObserverTarget");

#if DEBUG
	LogToFile(logpath, "Player %d -> Bot %d / ObsT %d", cid_player, cid_bot, obst);

	new pattern, specuid_bot, speccid_bot, specuid_obs, speccid_obs;
	specuid_bot = GetEntProp(cid_bot, Prop_Send, "m_humanSpectatorUserID");
	speccid_bot = GetEntProp(cid_bot, Prop_Send, "m_humanSpectatorEntIndex");
	specuid_obs = GetEntProp(obst, Prop_Send, "m_humanSpectatorUserID");
	speccid_obs = GetEntProp(obst, Prop_Send, "m_humanSpectatorEntIndex");
#endif
	/*
		引き継ぎ時におこりうるパターンは3パターンらしい
		1.正常パターン…引き継いだBotに値が指定される
		Bot == ObserverTarget
		
		2.設定対象誤りパターン（設定対象が別のBot）…引き継いだBotとは別のBotに値が指定される
		→引継ぎ時に出したBotとは別のBotに引き継がれる
		Bot != ObserverTarget && ObserverTargetがFakeclient
		
		3.設定対象誤りパターン（設定対象が人間のプレイヤー）…値が設定されない、または人間に対して値を指定しようとする
		→引き継ぎされずJoinできなくなる
		Bot != ObserverTarget && ObserverTargetが人間、または無効な値
	*/
	if (obst != cid_bot)
	{
		if (obst > 0 && obst <= MaxClients &&
			IsClientInGame(obst) &&
			(GetClientTeam(obst) == 2) &&
			IsFakeClient(obst))
		{
#if DEBUG	
			pattern = 2;
#endif
			//誤ったBotに対して設定された値をクリア
			SetEntProp(obst, Prop_Send, "m_humanSpectatorUserID", 0);
			SetEntProp(obst, Prop_Send, "m_humanSpectatorEntIndex", 0);
		}
#if DEBUG
		else pattern = 3;
#endif
		//引き継ぎBotに引き継ぎ元の設定を入力
		SetEntProp(cid_bot, Prop_Send, "m_humanSpectatorUserID", GetClientUserId(cid_player));
		SetEntProp(cid_bot, Prop_Send, "m_humanSpectatorEntIndex", cid_player);
	}
#if DEBUG
	else pattern = 1;
#endif

#if DEBUG
	LogToFile(logpath, "pattern:%d, specuid_bot:%d, speccid_obs:%d, specuid_obs:%d, speccid_obs:%d",
		pattern, specuid_bot, speccid_bot, specuid_obs, speccid_obs);
#endif
	
	Timer_Delay[cid_player] = INVALID_HANDLE;
}
